#include <dos.h>
#include <stdio.h>
#include <stdlib.h>
#include <math.h>
#include <time.h>

int xgamepad()
{
int padxval;
asm push ax;
asm push bx;
asm push cx;
asm push dx;
asm push ds;
asm push si;
asm push es;
asm push di;
asm mov ah, 084h;
asm mov dx, word ptr 1;
asm int 15h;
asm mov padxval, ax;
asm pop di;
asm pop es;
asm pop si;
asm pop ds;
asm pop dx;
asm pop cx;
asm pop bx;
asm pop ax;
return(padxval);
}

int ygamepad()
{
int padyval;
asm push ax;
asm push bx;
asm push cx;
asm push dx;
asm push ds;
asm push si;
asm push es;
asm push di;
asm mov ah, 084h;
asm mov dx, word ptr 1;
asm int 15h;
asm mov padyval, bx;
asm pop di;
asm pop es;
asm pop si;
asm pop ds;
asm pop dx;
asm pop cx;
asm pop bx;
asm pop ax;
return(padyval);
}

int x2gamepad()
{
int pad2xval;
asm push ax;
asm push bx;
asm push cx;
asm push dx;
asm push ds;
asm push si;
asm push es;
asm push di;
asm mov ah, 084h;
asm mov dx, word ptr 1;
asm int 15h;
asm mov pad2xval, cx;
asm pop di;
asm pop es;
asm pop si;
asm pop ds;
asm pop dx;
asm pop cx;
asm pop bx;
asm pop ax;
return(pad2xval);
}

int y2gamepad()
{
int pad2yval;
asm push ax;
asm push bx;
asm push cx;
asm push dx;
asm push ds;
asm push si;
asm push es;
asm push di;
asm mov ah, 084h;
asm mov dx, word ptr 1;
asm int 15h;
asm mov pad2yval, dx;
asm pop di;
asm pop es;
asm pop si;
asm pop ds;
asm pop dx;
asm pop cx;
asm pop bx;
asm pop ax;
return(pad2yval);
}

int buttongamepad()
{
int buttonval;
asm push ax;
asm push bx;
asm push cx;
asm push dx;
asm push ds;
asm push si;
asm push es;
asm push di;
asm mov ah, 084h;
asm mov dx, word ptr 0;
asm int 15h;
asm mov buttonval, ax;
asm pop di;
asm pop es;
asm pop si;
asm pop ds;
asm pop dx;
asm pop cx;
asm pop bx;
asm pop ax;
return(buttonval);
}

void setpage()
{
asm push ax;
asm push bx;
asm push cx;
asm push dx;
asm push ds;
asm push si;
asm push es;
asm push di;
asm mov al, 013h;
asm mov ah, 0;
asm int 10h;
asm pop di;
asm pop es;
asm pop si;
asm pop ds;
asm pop dx;
asm pop cx;
asm pop bx;
asm pop ax;
}

void retpage()
{
asm push ax;
asm push bx;
asm push cx;
asm push dx;
asm push ds;
asm push si;
asm push es;
asm push di;
asm mov al, 03h;
asm mov ah, 0;
asm int 10h;
asm pop di;
asm pop es;
asm pop si;
asm pop ds;
asm pop dx;
asm pop cx;
asm pop bx;
asm pop ax;
}

void plotxyc(int xint, int yint, int cint)
{
asm push ax;
asm push bx;
asm push cx;
asm push dx;
asm push ds;
asm push si;
asm push es;
asm push di;
asm mov ax, cint;
asm mov ah, 0ch;
asm mov cx, xint;
asm mov dx, yint;
asm int 10h;
asm pop di;
asm pop es;
asm pop si;
asm pop ds;
asm pop dx;
asm pop cx;
asm pop bx;
asm pop ax;
}

void spritedef()
{
asm GunDef DB 000,000,000,000,000;
asm DB 000,000,000,000,000;
asm DB 000,000,014,000,000;
asm DB 000,000,014,000,000;
asm DB 000,000,000,000,000;
asm DB 000,000,014,000,000;
asm DB 000,014,000,014,000;
asm DB 000,014,014,014,000;

asm BulDef DB 000,000,000,000,000;
asm DB 000,000,000,000,000;
asm DB 000,000,000,000,000;
asm DB 000,000,014,000,000;
asm DB 000,000,014,000,000;
asm DB 000,000,000,000,000;
asm DB 000,000,000,000,000;
asm DB 000,000,000,000,000;

asm ObjDef DB 000,000,000,000,000;
asm DB 000,000,000,000,000;
asm DB 000,000,000,000,000;
asm DB 000,000,000,000,000;
asm DB 000,015,015,015,000;
asm DB 000,000,000,000,000;
asm DB 000,015,015,015,000;
asm DB 000,000,000,000,000;

asm ExpDef DB 000,000,000,000,000;
asm DB 000,000,000,000,000;
asm DB 000,000,000,000,000;
asm DB 000,000,000,000,000;
asm DB 000,013,013,013,000;
asm DB 000,000,000,000,000;
asm DB 000,014,014,014,000;
asm DB 000,000,000,000,000;

asm LivDef DB 000,000,000,000,000;
asm DB 000,000,000,000,000;
asm DB 000,000,012,000,000;
asm DB 000,000,000,000,000;
asm DB 000,000,014,000,000;
asm DB 000,000,014,000,000;
asm DB 000,000,014,000,000;
asm DB 000,000,000,000,000;

asm BlkDef DB 000,000,000,000,000;
asm DB 000,000,000,000,000;
asm DB 000,000,000,000,000;
asm DB 000,000,000,000,000;
asm DB 000,000,000,000,000;
asm DB 000,000,000,000,000;
asm DB 000,000,000,000,000;
asm DB 000,000,000,000,000;

asm Q01Def DB 000,000,000,000,000;
asm DB 000,014,012,014,000;
asm DB 000,000,000,012,000;
asm DB 000,000,000,014,000;
asm DB 000,000,000,012,000;
asm DB 000,000,000,014,000;
asm DB 000,000,000,012,000;
asm DB 000,000,000,000,000;

asm Q02Def DB 000,000,000,000,000;
asm DB 000,000,000,014,000;
asm DB 000,000,000,012,000;
asm DB 000,000,000,014,000;
asm DB 000,000,000,012,000;
asm DB 000,000,000,014,000;
asm DB 000,012,014,012,000;
asm DB 000,000,000,000,000;

asm Q03Def DB 000,000,000,000,000;
asm DB 000,012,000,000,000;
asm DB 000,014,000,000,000;
asm DB 000,012,000,000,000;
asm DB 000,014,000,000,000;
asm DB 000,012,000,000,000;
asm DB 000,014,012,014,000;
asm DB 000,000,000,000,000;

asm Q04Def DB 000,000,000,000,000;
asm DB 000,012,014,012,000;
asm DB 000,014,000,000,000;
asm DB 000,012,000,000,000;
asm DB 000,014,000,000,000;
asm DB 000,012,000,000,000;
asm DB 000,014,000,000,000;
asm DB 000,000,000,000,000;
}

void plotspriteQ04(int xint, int yint)
{
asm push ax;
asm push bx;
asm push cx;
asm push dx;
asm push ds;
asm push si;
asm push es;
asm push di;
asm mov cx, xint;
asm mov dx, yint;
asm mov ax, SEG Q04Def;
asm mov ds, ax;
asm mov ax, OFFSET Q04Def;
asm mov si, ax;
asm mov bl, byte ptr 0;
asm mov bh, byte ptr 0;
repeatQ04Def:;
asm mov al, byte ptr ds:[si];
asm mov ah, 0ch;
asm int 10h;
asm inc si;
asm inc cx;
asm inc bl;
asm cmp bl, byte ptr 5;
asm jl repeatQ04Def;
asm mov bl, byte ptr 0;
asm inc bh;
asm clc;
asm sbb cx, word ptr 5;
asm inc dx;
asm cmp bh, byte ptr 8;
asm jl repeatQ04Def;
asm pop di;
asm pop es;
asm pop si;
asm pop ds;
asm pop dx;
asm pop cx;
asm pop bx;
asm pop ax;
}

void plotspriteQ03(int xint, int yint)
{
asm push ax;
asm push bx;
asm push cx;
asm push dx;
asm push ds;
asm push si;
asm push es;
asm push di;
asm mov cx, xint;
asm mov dx, yint;
asm mov ax, SEG Q03Def;
asm mov ds, ax;
asm mov ax, OFFSET Q03Def;
asm mov si, ax;
asm mov bl, byte ptr 0;
asm mov bh, byte ptr 0;
repeatQ03Def:;
asm mov al, byte ptr ds:[si];
asm mov ah, 0ch;
asm int 10h;
asm inc si;
asm inc cx;
asm inc bl;
asm cmp bl, byte ptr 5;
asm jl repeatQ03Def;
asm mov bl, byte ptr 0;
asm inc bh;
asm clc;
asm sbb cx, word ptr 5;
asm inc dx;
asm cmp bh, byte ptr 8;
asm jl repeatQ03Def;
asm pop di;
asm pop es;
asm pop si;
asm pop ds;
asm pop dx;
asm pop cx;
asm pop bx;
asm pop ax;
}

void plotspriteQ02(int xint, int yint)
{
asm push ax;
asm push bx;
asm push cx;
asm push dx;
asm push ds;
asm push si;
asm push es;
asm push di;
asm mov cx, xint;
asm mov dx, yint;
asm mov ax, SEG Q02Def;
asm mov ds, ax;
asm mov ax, OFFSET Q02Def;
asm mov si, ax;
asm mov bl, byte ptr 0;
asm mov bh, byte ptr 0;
repeatQ02Def:;
asm mov al, byte ptr ds:[si];
asm mov ah, 0ch;
asm int 10h;
asm inc si;
asm inc cx;
asm inc bl;
asm cmp bl, byte ptr 5;
asm jl repeatQ02Def;
asm mov bl, byte ptr 0;
asm inc bh;
asm clc;
asm sbb cx, word ptr 5;
asm inc dx;
asm cmp bh, byte ptr 8;
asm jl repeatQ02Def;
asm pop di;
asm pop es;
asm pop si;
asm pop ds;
asm pop dx;
asm pop cx;
asm pop bx;
asm pop ax;
}

void plotspriteQ01(int xint, int yint)
{
asm push ax;
asm push bx;
asm push cx;
asm push dx;
asm push ds;
asm push si;
asm push es;
asm push di;
asm mov cx, xint;
asm mov dx, yint;
asm mov ax, SEG Q01Def;
asm mov ds, ax;
asm mov ax, OFFSET Q01Def;
asm mov si, ax;
asm mov bl, byte ptr 0;
asm mov bh, byte ptr 0;
repeatQ01Def:;
asm mov al, byte ptr ds:[si];
asm mov ah, 0ch;
asm int 10h;
asm inc si;
asm inc cx;
asm inc bl;
asm cmp bl, byte ptr 5;
asm jl repeatQ01Def;
asm mov bl, byte ptr 0;
asm inc bh;
asm clc;
asm sbb cx, word ptr 5;
asm inc dx;
asm cmp bh, byte ptr 8;
asm jl repeatQ01Def;
asm pop di;
asm pop es;
asm pop si;
asm pop ds;
asm pop dx;
asm pop cx;
asm pop bx;
asm pop ax;
}

void plotspriteGun(int xint, int yint)
{
asm push ax;
asm push bx;
asm push cx;
asm push dx;
asm push ds;
asm push si;
asm push es;
asm push di;
asm mov cx, xint;
asm mov dx, yint;
asm mov ax, SEG GunDef;
asm mov ds, ax;
asm mov ax, OFFSET GunDef;
asm mov si, ax;
asm mov bl, byte ptr 0;
asm mov bh, byte ptr 0;
repeatGunDef:;
asm mov al, byte ptr ds:[si];
asm mov ah, 0ch;
asm int 10h;
asm inc si;
asm inc cx;
asm inc bl;
asm cmp bl, byte ptr 5;
asm jl repeatGunDef;
asm mov bl, byte ptr 0;
asm inc bh;
asm clc;
asm sbb cx, word ptr 5;
asm inc dx;
asm cmp bh, byte ptr 8;
asm jl repeatGunDef;
asm pop di;
asm pop es;
asm pop si;
asm pop ds;
asm pop dx;
asm pop cx;
asm pop bx;
asm pop ax;
}

void plotspriteBul(int xint, int yint)
{
asm push ax;
asm push bx;
asm push cx;
asm push dx;
asm push ds;
asm push si;
asm push es;
asm push di;
asm mov cx, xint;
asm mov dx, yint;
asm mov ax, SEG BulDef;
asm mov ds, ax;
asm mov ax, OFFSET BulDef;
asm mov si, ax;
asm mov bl, byte ptr 0;
asm mov bh, byte ptr 0;
repeatGunDef:;
asm mov al, byte ptr ds:[si];
asm mov ah, 0ch;
asm int 10h;
asm inc si;
asm inc cx;
asm inc bl;
asm cmp bl, byte ptr 5;
asm jl repeatGunDef;
asm mov bl, byte ptr 0;
asm inc bh;
asm clc;
asm sbb cx, word ptr 5;
asm inc dx;
asm cmp bh, byte ptr 8;
asm jl repeatGunDef;
asm pop di;
asm pop es;
asm pop si;
asm pop ds;
asm pop dx;
asm pop cx;
asm pop bx;
asm pop ax;
}

void plotspriteExp(int xint, int yint)
{
asm push ax;
asm push bx;
asm push cx;
asm push dx;
asm push ds;
asm push si;
asm push es;
asm push di;
asm mov cx, xint;
asm mov dx, yint;
asm mov ax, SEG ExpDef;
asm mov ds, ax;
asm mov ax, OFFSET ExpDef;
asm mov si, ax;
asm mov bl, byte ptr 0;
asm mov bh, byte ptr 0;
repeatExpDef:;
asm mov al, byte ptr ds:[si];
asm mov ah, 0ch;
asm int 10h;
asm inc si;
asm inc cx;
asm inc bl;
asm cmp bl, byte ptr 5;
asm jl repeatExpDef;
asm mov bl, byte ptr 0;
asm inc bh;
asm clc;
asm sbb cx, word ptr 5;
asm inc dx;
asm cmp bh, byte ptr 8;
asm jl repeatExpDef;
asm pop di;
asm pop es;
asm pop si;
asm pop ds;
asm pop dx;
asm pop cx;
asm pop bx;
asm pop ax;
}

void plotspriteObj(int xint, int yint)
{
asm push ax;
asm push bx;
asm push cx;
asm push dx;
asm push ds;
asm push si;
asm push es;
asm push di;
asm mov cx, xint;
asm mov dx, yint;
asm mov ax, SEG ObjDef;
asm mov ds, ax;
asm mov ax, OFFSET ObjDef;
asm mov si, ax;
asm mov bl, byte ptr 0;
asm mov bh, byte ptr 0;
repeatObjDef:;
asm mov al, byte ptr ds:[si];
asm mov ah, 0ch;
asm int 10h;
asm inc si;
asm inc cx;
asm inc bl;
asm cmp bl, byte ptr 5;
asm jl repeatObjDef;
asm mov bl, byte ptr 0;
asm inc bh;
asm clc;
asm sbb cx, word ptr 5;
asm inc dx;
asm cmp bh, byte ptr 8;
asm jl repeatObjDef;
asm pop di;
asm pop es;
asm pop si;
asm pop ds;
asm pop dx;
asm pop cx;
asm pop bx;
asm pop ax;
}

void plotspriteLiv(int xint, int yint)
{
asm push ax;
asm push bx;
asm push cx;
asm push dx;
asm push ds;
asm push si;
asm push es;
asm push di;
asm mov cx, xint;
asm mov dx, yint;
asm mov ax, SEG LivDef;
asm mov ds, ax;
asm mov ax, OFFSET LivDef;
asm mov si, ax;
asm mov bl, byte ptr 0;
asm mov bh, byte ptr 0;
repeatLivDef:;
asm mov al, byte ptr ds:[si];
asm mov ah, 0ch;
asm int 10h;
asm inc si;
asm inc cx;
asm inc bl;
asm cmp bl, byte ptr 5;
asm jl repeatLivDef;
asm mov bl, byte ptr 0;
asm inc bh;
asm clc;
asm sbb cx, word ptr 5;
asm inc dx;
asm cmp bh, byte ptr 8;
asm jl repeatLivDef;
asm pop di;
asm pop es;
asm pop si;
asm pop ds;
asm pop dx;
asm pop cx;
asm pop bx;
asm pop ax;
}

void plotspriteBlk(int xint, int yint)
{
asm push ax;
asm push bx;
asm push cx;
asm push dx;
asm push ds;
asm push si;
asm push es;
asm push di;
asm mov cx, xint;
asm mov dx, yint;
asm mov ax, SEG BlkDef;
asm mov ds, ax;
asm mov ax, OFFSET BlkDef;
asm mov si, ax;
asm mov bl, byte ptr 0;
asm mov bh, byte ptr 0;
repeatBlkDef:;
asm mov al, byte ptr ds:[si];
asm mov ah, 0ch;
asm int 10h;
asm inc si;
asm inc cx;
asm inc bl;
asm cmp bl, byte ptr 5;
asm jl repeatBlkDef;
asm mov bl, byte ptr 0;
asm inc bh;
asm clc;
asm sbb cx, word ptr 5;
asm inc dx;
asm cmp bh, byte ptr 8;
asm jl repeatBlkDef;
asm pop di;
asm pop es;
asm pop si;
asm pop ds;
asm pop dx;
asm pop cx;
asm pop bx;
asm pop ax;
}

#pragma saveregs
unsigned int convertedAHAL(int dupAL2, int dupAH2)
{
unsigned int dupAXreturned;
asm push ax;
asm push bx;
asm mov bx, dupAL2;
asm mov al, bl;
asm mov bx, dupAH2;
asm mov ah, bl;
asm mov dupAXreturned, ax;
asm pop bx;
asm pop ax;
return(dupAXreturned);
}

/*
int main()
{
unsigned int LowVal;
unsigned int HiVal;
unsigned long CombinedVal;

int dupAH, dupAL;
int dupDH, dupDL;

dupAH = 0;
dupAL = 1;
dupDH = 0;
dupDL = 1;

LowVal = dupAX(dupAH, dupAL);
HiVal = dupAX(dupDH, dupDL);
CombinedVal = (long)((HiVal*65536)+LowVal);
printf("\n %d %d %ld", LowVal, HiVal, CombinedVal);
getch();

return(0);
}
*/

#pragma saveregs
long int convertDXAX(unsigned int HiVal, unsigned int LowVal)
{
long CombinedVal;

CombinedVal = (long)((HiVal*65536)+LowVal);

return(CombinedVal);
}

void loadbitmap5(int picturenumber)
{
unsigned int pal[256*5], index;

FILE *in;

unsigned char pixeldatain;

double tempxpos, xpos, ypos;

double xposi;

unsigned char tempAH[50], tempAL[50];
unsigned long tempAX[50];

unsigned long ntimes, BMPbytes, OffSetbytes;
unsigned long HeadSize, Width, Height;
unsigned int nColorPanes, BitsPerPixel;
unsigned long Compression;
unsigned long ImageSize, hRes, vRes;
unsigned long nColors, nImportant;

unsigned long PixelArraySize;

double RowSize;

unsigned int xdisplaycount, ydisplaycount, actualpixel;
unsigned long npixels, temp, totalcount;

int padding;

char keypress;

double radian, fullradian, currentradian;
double degree, radius;
double centerx, centery;
int ix, iy, pixcolor;

double center2x, center2y;
int i2x, i2y;

unsigned long pause;

double proportionx, proportiony;

pixeldatain = 0;

if(picturenumber == 1)
{
in = fopen("JesusGOD.bmp", "rb");
if(in == NULL)
{
goto exitloadbitmap5;
}
}
else
{
in = fopen("mom+dad.bmp", "rb");
if(in == NULL)
{
goto exitloadbitmap5;
}
}

system("cls");

ntimes = 1;
tempAH[ntimes] = fgetc(in);
tempAL[ntimes] = fgetc(in);
tempAX[ntimes] = convertedAHAL(tempAH[ntimes], tempAL[ntimes]);
printf("\n AH AL %c %c", tempAH[ntimes], tempAL[ntimes]);

ntimes = 2;
tempAH[ntimes] = fgetc(in);
tempAL[ntimes] = fgetc(in);
tempAX[ntimes] = convertedAHAL(tempAH[ntimes], tempAL[ntimes]);
printf("\n DH DL DX %d %d %ld", tempAH[ntimes], tempAL[ntimes], tempAX[ntimes]);
ntimes = 3;
tempAH[ntimes] = fgetc(in);
tempAL[ntimes] = fgetc(in);
tempAX[ntimes] = convertedAHAL(tempAH[ntimes], tempAL[ntimes]);
printf("\n AH AL AX %d %d %ld", tempAH[ntimes], tempAL[ntimes], tempAX[ntimes]);
BMPbytes = convertDXAX(tempAX[3], tempAX[2]);
printf("\n BMPbytes %ld", BMPbytes);

ntimes = 4;
tempAH[ntimes] = fgetc(in);
tempAL[ntimes] = fgetc(in);
tempAX[ntimes] = convertedAHAL(tempAH[ntimes], tempAL[ntimes]);
printf("\n N/A AH AL AX %d %d %ld", tempAH[ntimes], tempAL[ntimes], tempAX[ntimes]);

ntimes = 5;
tempAH[ntimes] = fgetc(in);
tempAL[ntimes] = fgetc(in);
tempAX[ntimes] = convertedAHAL(tempAH[ntimes], tempAL[ntimes]);
printf("\n N/A AH AL AX %d %d %ld", tempAH[ntimes], tempAL[ntimes], tempAX[ntimes]);

ntimes = 7;
tempAH[ntimes] = fgetc(in);
tempAL[ntimes] = fgetc(in);
tempAX[ntimes] = convertedAHAL(tempAH[ntimes], tempAL[ntimes]);
ntimes = 8;
tempAH[ntimes] = fgetc(in);
tempAL[ntimes] = fgetc(in);
tempAX[ntimes] = convertedAHAL(tempAH[ntimes], tempAL[ntimes]);
OffSetbytes = convertDXAX(tempAX[8], tempAX[7]);
printf("\n OffSetbytes %ld", OffSetbytes);

ntimes = 9;
tempAH[ntimes] = fgetc(in);
tempAL[ntimes] = fgetc(in);
tempAX[ntimes] = convertedAHAL(tempAH[ntimes], tempAL[ntimes]);
ntimes = 10;
tempAH[ntimes] = fgetc(in);
tempAL[ntimes] = fgetc(in);
tempAX[ntimes] = convertedAHAL(tempAH[ntimes], tempAL[ntimes]);
HeadSize = convertDXAX(tempAX[10], tempAX[9]);
printf("\n HeadSize %ld", HeadSize);

ntimes = 11;
tempAH[ntimes] = fgetc(in);
tempAL[ntimes] = fgetc(in);
tempAX[ntimes] = convertedAHAL(tempAH[ntimes], tempAL[ntimes]);
ntimes = 12;
tempAH[ntimes] = fgetc(in);
tempAL[ntimes] = fgetc(in);
tempAX[ntimes] = convertedAHAL(tempAH[ntimes], tempAL[ntimes]);
Width = convertDXAX(tempAX[12], tempAX[11]);
printf("\n Width %ld", Width);

ntimes = 14;
tempAH[ntimes] = fgetc(in);
tempAL[ntimes] = fgetc(in);
tempAX[ntimes] = convertedAHAL(tempAH[ntimes], tempAL[ntimes]);
ntimes = 15;
tempAH[ntimes] = fgetc(in);
tempAL[ntimes] = fgetc(in);
tempAX[ntimes] = convertedAHAL(tempAH[ntimes], tempAL[ntimes]);
Height = convertDXAX(tempAX[15], tempAX[14]);
printf("\n Height %ld", Height);

ntimes = 16;
tempAH[ntimes] = fgetc(in);
tempAL[ntimes] = fgetc(in);
nColorPanes = convertedAHAL(tempAH[ntimes], tempAL[ntimes]);
printf("\n nColorPanes %d", nColorPanes);
ntimes = 17;
tempAH[ntimes] = fgetc(in);
tempAL[ntimes] = fgetc(in);
BitsPerPixel = convertedAHAL(tempAH[ntimes], tempAL[ntimes]);
printf("\n BitsPerPixel %d", BitsPerPixel);

ntimes = 18;
tempAH[ntimes] = fgetc(in);
tempAL[ntimes] = fgetc(in);
tempAX[ntimes] = convertedAHAL(tempAH[ntimes], tempAL[ntimes]);
ntimes = 19;
tempAH[ntimes] = fgetc(in);
tempAL[ntimes] = fgetc(in);
tempAX[ntimes] = convertedAHAL(tempAH[ntimes], tempAL[ntimes]);
Compression = convertDXAX(tempAX[19], tempAX[18]);
printf("\n Compression %ld", Compression);

ntimes = 20;
tempAH[ntimes] = fgetc(in);
tempAL[ntimes] = fgetc(in);
tempAX[ntimes] = convertedAHAL(tempAH[ntimes], tempAL[ntimes]);
ntimes = 21;
tempAH[ntimes] = fgetc(in);
tempAL[ntimes] = fgetc(in);
tempAX[ntimes] = convertedAHAL(tempAH[ntimes], tempAL[ntimes]);
ImageSize = convertDXAX(tempAX[21], tempAX[20]);
printf("\n ImageSize %ld", ImageSize);

ntimes = 22;
tempAH[ntimes] = fgetc(in);
tempAL[ntimes] = fgetc(in);
tempAX[ntimes] = convertedAHAL(tempAH[ntimes], tempAL[ntimes]);
ntimes = 23;
tempAH[ntimes] = fgetc(in);
tempAL[ntimes] = fgetc(in);
tempAX[ntimes] = convertedAHAL(tempAH[ntimes], tempAL[ntimes]);
hRes = convertDXAX(tempAX[23], tempAX[22]);
printf("\n hRes %ld", hRes);

ntimes = 24;
tempAH[ntimes] = fgetc(in);
tempAL[ntimes] = fgetc(in);
tempAX[ntimes] = convertedAHAL(tempAH[ntimes], tempAL[ntimes]);
ntimes = 25;
tempAH[ntimes] = fgetc(in);
tempAL[ntimes] = fgetc(in);
tempAX[ntimes] = convertedAHAL(tempAH[ntimes], tempAL[ntimes]);
vRes = convertDXAX(tempAX[25], tempAX[24]);
printf("\n vRes %ld", vRes);

ntimes = 26;
tempAH[ntimes] = fgetc(in);
tempAL[ntimes] = fgetc(in);
tempAX[ntimes] = convertedAHAL(tempAH[ntimes], tempAL[ntimes]);
ntimes = 27;
tempAH[ntimes] = fgetc(in);
tempAL[ntimes] = fgetc(in);
tempAX[ntimes] = convertedAHAL(tempAH[ntimes], tempAL[ntimes]);
nColors = convertDXAX(tempAX[27], tempAX[26]);
printf("\n nColors %ld", nColors);

ntimes = 28;
tempAH[ntimes] = fgetc(in);
tempAL[ntimes] = fgetc(in);
tempAX[ntimes] = convertedAHAL(tempAH[ntimes], tempAL[ntimes]);
ntimes = 29;
tempAH[ntimes] = fgetc(in);
tempAL[ntimes] = fgetc(in);
tempAX[ntimes] = convertedAHAL(tempAH[ntimes], tempAL[ntimes]);
nImportant = convertDXAX(tempAX[29], tempAX[28]);
printf("\n nImportant %ld", nImportant);

RowSize = (((BitsPerPixel*Width)+31)/32)*4;
PixelArraySize = RowSize*(abs(Height));
printf("\n RowSize %ld", RowSize);
printf("\n PixelArraySize %ld", PixelArraySize);

if((Width*Height)>(320*200))
{
printf("\n\n Bitmap cannot fit buffer!");
getch();
goto exitrle;
}

getch();

for(index=0;index < 256;index++)
  {
    pal[(int)(index*3+2)] = fgetc(in) >> 2;
    pal[(int)(index*3+1)] = fgetc(in) >> 2;
    pal[(int)(index*3+0)] = fgetc(in) >> 2;
    tempAH[30]=fgetc(in);
  }

setpage();

if(BitsPerPixel != 8)
{
system("cls");
printf("\n I'm sorry.");
printf("\n Only 8 Bits Per Pixel Uncompressed");
printf("\n  with 256 Color .BMP is supported.");
goto exitrle;
}

/*
for(ntimes = 0; ntimes < OffSetbytes-(40+14); ntimes++)
{
pixeldatain = fgetc(in);
}
*/


pixeldatain = fgetc(in);

if(Compression != 0)
{
goto checkrle;
}

xposi = 1;
for(ypos = 0; ypos < Height; ypos++)
{
tempxpos = 0;
for(xpos = 0; xpos < RowSize; xpos = xpos + xposi)
{
pixeldatain = fgetc(in);
asm mov bx, pixeldatain;
asm mov ah, 0;
asm mov al, bl;
asm mov tempAL[30], ax;
tempxpos = tempxpos + 1;
plotxyc(tempxpos, Height-ypos, pixeldatain);
/*
loadscreen1buffer(RowSize, Height, tempxpos, Height-ypos, pixeldatain);
*/
/*
asm mov bx, pixeldatain;
asm mov ah, 0;
asm mov al, bh;
asm mov tempAH[30], ax;
tempxpos = tempxpos + 1;
plotxyc(tempxpos, 200-ypos, tempAH[30]);
*/
}

}





radian = 3.1415927;
fullradian = 2*radian;
degree = fullradian/(350*3);
radius = 80.0;

repeatcirclereveal:;

centerx = 155;
centery = 100;

center2x = RowSize/2;
center2y = Height/2;

/*
for(radius = 0; radius < 200; radius++)
{
for(currentradian = 0; currentradian < fullradian; currentradian = currentradian + degree)
{
ix = (int)(centerx+cos(currentradian)*radius);
iy = (int)(centery+sin(currentradian)*radius);
i2x = (int)(center2x+cos(currentradian)*radius);
i2y = (int)(center2y+sin(currentradian)*radius);
if((ix < 0)||(ix >= 320)||(iy < 0)||(iy >= 200))
{
}
else
{
pixcolor = queryscreen1buffer(RowSize, Height, i2x, i2y);
plotxyc(ix, iy, pixcolor);
}

if( kbhit() )
{
keypress = getch();

if( keypress == 'q' )
{
goto exitcirclereveal;
}
}
}

}

exitcirclereveal:;
*/

proportionx = 320/RowSize;
proportiony = 200/Height;
for(i2y = 0; i2y < Height; i2y++)
{
for(i2x = 0; i2x < RowSize; i2x++)
{
/*
pixcolor = queryscreen1buffer(RowSize, Height, i2x, i2y);
*/
for(iy = 0; iy < proportiony; iy++)
{
for(ix = 0; ix < proportionx; ix++)
{
/*
plotpixel2((i2x*proportionx)+ix, (i2y*proportiony)+iy, pixcolor);
*/
}
}


}
}




outp(0x03c8, 0);
for(index=0; index < 256*3; index++)
{
outp(0x03c9, pal[index]);
}

goto exitrle;

checkrle:;
if(Compression != 1)
{
goto exitrle;
}

system("cls");
printf("\n I'm sorry.");
printf("\n Compressed bitmaps not supported.");
getch();

xdisplaycount = 0;
ydisplaycount = 0;
totalcount = 0;

repeatloadrle:;
totalcount++;
if(totalcount > (320*200) )
{
goto exitrle;
}


npixels = fgetc(in);
if(npixels == 0)
{

npixels = fgetc(in);
if(npixels == 0)
{
xdisplaycount = Width;
goto repeatloadrle;
}
if(npixels == 1)
{
goto exitrle;
}
if(npixels == 2)
{
actualpixel = fgetc(in);
xdisplaycount = xdisplaycount + actualpixel;
actualpixel = fgetc(in);
ydisplaycount = ydisplaycount + actualpixel;
goto repeatloadrle;
}
if(npixels > 2)
{
actualpixel = fgetc(in);
for(temp = 0; temp < npixels; temp++)
{
xdisplaycount++;
if(xdisplaycount > Width)
{
xdisplaycount = 0;
ydisplaycount++;
if(ydisplaycount > Height)
{
goto exitrle;
}
}
plotxyc(xdisplaycount, 200-ydisplaycount, actualpixel);
}
goto repeatloadrle;
}

}
goto repeatloadrle;

exitrle:;

fclose(in);

exitloadbitmap5:;
}

void loadbitmap12()
{
unsigned int pal[256*5], index;

FILE *in;

unsigned char pixeldatain;

double tempxpos, xpos, ypos;

double xposi;

unsigned char tempAH[50], tempAL[50];
unsigned long tempAX[50];

unsigned long ntimes, BMPbytes, OffSetbytes;
unsigned long HeadSize, Width, Height;
unsigned int nColorPanes, BitsPerPixel;
unsigned long Compression;
unsigned long ImageSize, hRes, vRes;
unsigned long nColors, nImportant;

unsigned long PixelArraySize;

double RowSize;

unsigned int xdisplaycount, ydisplaycount, actualpixel;
unsigned long npixels, temp, totalcount;

int padding;

char keypress;

double radian, fullradian, currentradian;
double degree, radius;
double centerx, centery;
int ix, iy, pixcolor;

double center2x, center2y;
int i2x, i2y;

unsigned long pause;

double proportionx, proportiony;

pixeldatain = 0;

in = fopen("xenon", "rb");
if(in == NULL)
{
goto exitloadbitmap12;
}

ntimes = 1;
tempAH[ntimes] = fgetc(in);
tempAL[ntimes] = fgetc(in);
tempAX[ntimes] = convertedAHAL(tempAH[ntimes], tempAL[ntimes]);
printf("\n AH AL %c %c", tempAH[ntimes], tempAL[ntimes]);

ntimes = 2;
tempAH[ntimes] = fgetc(in);
tempAL[ntimes] = fgetc(in);
tempAX[ntimes] = convertedAHAL(tempAH[ntimes], tempAL[ntimes]);
printf("\n DH DL DX %d %d %ld", tempAH[ntimes], tempAL[ntimes], tempAX[ntimes]);
ntimes = 3;
tempAH[ntimes] = fgetc(in);
tempAL[ntimes] = fgetc(in);
tempAX[ntimes] = convertedAHAL(tempAH[ntimes], tempAL[ntimes]);
printf("\n AH AL AX %d %d %ld", tempAH[ntimes], tempAL[ntimes], tempAX[ntimes]);
BMPbytes = convertDXAX(tempAX[3], tempAX[2]);
printf("\n BMPbytes %ld", BMPbytes);

ntimes = 4;
tempAH[ntimes] = fgetc(in);
tempAL[ntimes] = fgetc(in);
tempAX[ntimes] = convertedAHAL(tempAH[ntimes], tempAL[ntimes]);
printf("\n N/A AH AL AX %d %d %ld", tempAH[ntimes], tempAL[ntimes], tempAX[ntimes]);

ntimes = 5;
tempAH[ntimes] = fgetc(in);
tempAL[ntimes] = fgetc(in);
tempAX[ntimes] = convertedAHAL(tempAH[ntimes], tempAL[ntimes]);
printf("\n N/A AH AL AX %d %d %ld", tempAH[ntimes], tempAL[ntimes], tempAX[ntimes]);

ntimes = 7;
tempAH[ntimes] = fgetc(in);
tempAL[ntimes] = fgetc(in);
tempAX[ntimes] = convertedAHAL(tempAH[ntimes], tempAL[ntimes]);
ntimes = 8;
tempAH[ntimes] = fgetc(in);
tempAL[ntimes] = fgetc(in);
tempAX[ntimes] = convertedAHAL(tempAH[ntimes], tempAL[ntimes]);
OffSetbytes = convertDXAX(tempAX[8], tempAX[7]);
printf("\n OffSetbytes %ld", OffSetbytes);

ntimes = 9;
tempAH[ntimes] = fgetc(in);
tempAL[ntimes] = fgetc(in);
tempAX[ntimes] = convertedAHAL(tempAH[ntimes], tempAL[ntimes]);
ntimes = 10;
tempAH[ntimes] = fgetc(in);
tempAL[ntimes] = fgetc(in);
tempAX[ntimes] = convertedAHAL(tempAH[ntimes], tempAL[ntimes]);
HeadSize = convertDXAX(tempAX[10], tempAX[9]);
printf("\n HeadSize %ld", HeadSize);

ntimes = 11;
tempAH[ntimes] = fgetc(in);
tempAL[ntimes] = fgetc(in);
tempAX[ntimes] = convertedAHAL(tempAH[ntimes], tempAL[ntimes]);
ntimes = 12;
tempAH[ntimes] = fgetc(in);
tempAL[ntimes] = fgetc(in);
tempAX[ntimes] = convertedAHAL(tempAH[ntimes], tempAL[ntimes]);
Width = convertDXAX(tempAX[12], tempAX[11]);
printf("\n Width %ld", Width);

ntimes = 14;
tempAH[ntimes] = fgetc(in);
tempAL[ntimes] = fgetc(in);
tempAX[ntimes] = convertedAHAL(tempAH[ntimes], tempAL[ntimes]);
ntimes = 15;
tempAH[ntimes] = fgetc(in);
tempAL[ntimes] = fgetc(in);
tempAX[ntimes] = convertedAHAL(tempAH[ntimes], tempAL[ntimes]);
Height = convertDXAX(tempAX[15], tempAX[14]);
printf("\n Height %ld", Height);

ntimes = 16;
tempAH[ntimes] = fgetc(in);
tempAL[ntimes] = fgetc(in);
nColorPanes = convertedAHAL(tempAH[ntimes], tempAL[ntimes]);
printf("\n nColorPanes %d", nColorPanes);
ntimes = 17;
tempAH[ntimes] = fgetc(in);
tempAL[ntimes] = fgetc(in);
BitsPerPixel = convertedAHAL(tempAH[ntimes], tempAL[ntimes]);
printf("\n BitsPerPixel %d", BitsPerPixel);

ntimes = 18;
tempAH[ntimes] = fgetc(in);
tempAL[ntimes] = fgetc(in);
tempAX[ntimes] = convertedAHAL(tempAH[ntimes], tempAL[ntimes]);
ntimes = 19;
tempAH[ntimes] = fgetc(in);
tempAL[ntimes] = fgetc(in);
tempAX[ntimes] = convertedAHAL(tempAH[ntimes], tempAL[ntimes]);
Compression = convertDXAX(tempAX[19], tempAX[18]);
printf("\n Compression %ld", Compression);

ntimes = 20;
tempAH[ntimes] = fgetc(in);
tempAL[ntimes] = fgetc(in);
tempAX[ntimes] = convertedAHAL(tempAH[ntimes], tempAL[ntimes]);
ntimes = 21;
tempAH[ntimes] = fgetc(in);
tempAL[ntimes] = fgetc(in);
tempAX[ntimes] = convertedAHAL(tempAH[ntimes], tempAL[ntimes]);
ImageSize = convertDXAX(tempAX[21], tempAX[20]);
printf("\n ImageSize %ld", ImageSize);

ntimes = 22;
tempAH[ntimes] = fgetc(in);
tempAL[ntimes] = fgetc(in);
tempAX[ntimes] = convertedAHAL(tempAH[ntimes], tempAL[ntimes]);
ntimes = 23;
tempAH[ntimes] = fgetc(in);
tempAL[ntimes] = fgetc(in);
tempAX[ntimes] = convertedAHAL(tempAH[ntimes], tempAL[ntimes]);
hRes = convertDXAX(tempAX[23], tempAX[22]);
printf("\n hRes %ld", hRes);

ntimes = 24;
tempAH[ntimes] = fgetc(in);
tempAL[ntimes] = fgetc(in);
tempAX[ntimes] = convertedAHAL(tempAH[ntimes], tempAL[ntimes]);
ntimes = 25;
tempAH[ntimes] = fgetc(in);
tempAL[ntimes] = fgetc(in);
tempAX[ntimes] = convertedAHAL(tempAH[ntimes], tempAL[ntimes]);
vRes = convertDXAX(tempAX[25], tempAX[24]);
printf("\n vRes %ld", vRes);

ntimes = 26;
tempAH[ntimes] = fgetc(in);
tempAL[ntimes] = fgetc(in);
tempAX[ntimes] = convertedAHAL(tempAH[ntimes], tempAL[ntimes]);
ntimes = 27;
tempAH[ntimes] = fgetc(in);
tempAL[ntimes] = fgetc(in);
tempAX[ntimes] = convertedAHAL(tempAH[ntimes], tempAL[ntimes]);
nColors = convertDXAX(tempAX[27], tempAX[26]);
printf("\n nColors %ld", nColors);

ntimes = 28;
tempAH[ntimes] = fgetc(in);
tempAL[ntimes] = fgetc(in);
tempAX[ntimes] = convertedAHAL(tempAH[ntimes], tempAL[ntimes]);
ntimes = 29;
tempAH[ntimes] = fgetc(in);
tempAL[ntimes] = fgetc(in);
tempAX[ntimes] = convertedAHAL(tempAH[ntimes], tempAL[ntimes]);
nImportant = convertDXAX(tempAX[29], tempAX[28]);
printf("\n nImportant %ld", nImportant);

for(index=0;index < 256;index++)
  {
    pal[(int)(index*3+2)] = fgetc(in) >> 2;
    pal[(int)(index*3+1)] = fgetc(in) >> 2;
    pal[(int)(index*3+0)] = fgetc(in) >> 2;
    tempAH[30]=fgetc(in);
  }

outp(0x03c8, 0);
for(index=0; index < 256*3; index++)
{
outp(0x03c9, pal[index]);
}

exitloadbitmap12:;
fclose(in);
}

int Pitch(int NoteLocation)
{
int retPitch, retDuration;

asm push ax;
asm push bx;
asm push cx;
asm push dx;
asm push ds;
asm push si;
asm push es;
asm push di;

asm mov bx, NoteLocation;
asm mov ax, SEG Notes;
asm mov ds, ax;
asm mov es, ax;
asm mov ax, OFFSET Notes;
asm mov si, ax;
asm mov di, ax;
asm inc di;

asm mov cx, word ptr es:[di+bx];
asm mov dx, word ptr ds:[si+bx];
asm mov retDuration, cx;
asm mov retPitch, dx;

asm pop di;
asm pop es;
asm pop si;
asm pop ds;
asm pop dx;
asm pop cx;
asm pop bx;
asm pop ax;
return(retPitch);

asm Notes DW 300, 100;
asm DW 800, 100;
asm DW 1200, 100;
asm DW 1200, 400;
asm DW 800, 400;
asm DW 1200, 400;
asm DW 800, 100;
asm DW 300, 100;
asm DW 800, 100;
asm DW 1200, 100;
asm DW 1200, 400;
asm DW 800, 300;
asm DW 500, 100;
asm DW 800, 100;
asm DW 1200, 100;
asm DW 1200, 200;
asm DW 1000, 200;
asm DW 800, 100;
asm DW 500, 100;
asm DW 800, 100;
asm DW 1200, 300;
asm DW 1000, 200;
asm DW 800, 100;
asm DW 500, 100;
asm DW 800, 100;
asm DW 1200, 300;
asm DW 1000, 200;
asm DW 800, 200;
asm DW 800, 800;
asm DW 0, 0;
}

int Duration(int NoteLocation)
{
int retPitch, retDuration;

asm push ax;
asm push bx;
asm push cx;
asm push dx;
asm push ds;
asm push si;
asm push es;
asm push di;

asm mov bx, NoteLocation;
asm mov ax, SEG Notes;
asm mov ds, ax;
asm mov es, ax;
asm mov ax, OFFSET Notes;
asm mov si, ax;
asm mov di, ax;
asm inc di;

asm mov cx, word ptr es:[di+bx];
asm mov dx, word ptr ds:[si+bx];
asm mov retDuration, cx;
asm mov retPitch, dx;

asm pop di;
asm pop es;
asm pop si;
asm pop ds;
asm pop dx;
asm pop cx;
asm pop bx;
asm pop ax;
return(retDuration);
}

int main()
{
double doublex[100], doubley[100], doublei[100];
int inttemp;

int xpos, ypos, ipos;
int Bulxpos, Bulypos, Bulipos;
double Objxpos, Objypos, Objipos;
int ObjxD, ObjyD;

int Livxpos, Livypos, Livipos;
int Lives, MaxLives, Work;
int TouchCount;

int setBul;

int ShellBulxpos[100], ShellBulypos[100], ShellBulipos[100];
int ShellsetBul[100], temp;

char keypress, cheat, gamepad;

unsigned long delay, maxspeed;

unsigned long lookcount, lovecount;

int frqHertz;

double Qn[100];

unsigned long Patient;

double centerx, centery, radian, fullradian, currentradian;
int ix, iy;
double radius, degree;

char soundopt;

int NotePitch, NoteDuration, NotePause, NotePosition;

NotePitch = 0;
NoteDuration = 0;
NotePause = 0;
NotePosition = 0;

soundopt = 'y';

centerx = 155.0;
centery = 100.0;
radian = 3.14159265;
fullradian = 2.0*radian;
currentradian = 0.0;
radius = 25.0;
degree = fullradian/360.0;

srand(time(NULL));

cheat = 'n';

keypress = '';

TouchCount = 0;

gamepad = '';

for(inttemp = 0; inttemp < 100; inttemp++)
{
doublex[inttemp] = (double)(rand()%320);
doubley[inttemp] = 48.0+(double)(rand()%(180-48));
doublei[inttemp] = ((double)(rand()%10))/10.0;
Qn[inttemp] = 0.00;

ShellBulipos[inttemp] = 1;
ShellBulxpos[inttemp] = 155;
ShellBulypos[inttemp] = 180;
ShellsetBul[inttemp] = 0;
}

ipos = 1;
xpos = 155;
ypos = 180;

setBul = 0;

Bulipos = 1;
Bulxpos = 155;
Bulypos = 180;

Objipos = 0.1+(((double)(rand()%10))/10.0);
Objxpos = 1.0+(((double)(rand()%312))/1.0);
Objypos = 48.0;
ObjxD = 1;
ObjyD = 2;

Livipos = 1;
Livxpos = 1;
Livypos = 190;

Lives = 53;
MaxLives = 100;
Patient = 0;

maxspeed = 12000;

menu:;
system("cls");
printf("\n Thank you Jesus Christ.");
printf("\n Honours to my real mom:  Huong Thi Vu");
printf("\n Honours to my real dad:  Nguyen Binh Thuy");
printf("\n Bless my real mom too.");
printf("\n ");
printf("\n Created using Turbo C, Copyright (C) Borland 1987, 1988.");
printf("\n ");
printf("\n Keys during game are: a-left, d-right, f-fire, q-quit.");
printf("\n The object of the game is to touch the ship 100 times.");
printf("\n Please press a key to continue.  Thx.");
printf("\n");
printf("\n [T]est gamepad in DOSBox (0.74).");
printf("\n [G]amepad(s) in use for PC.");
printf("\n");
printf("\n Gamepad requires:");
printf("\n  Microsoft XBOX360 gamepad/controller");
printf("\n  SONY PS ONE gamepad/controller");
printf("\n   (both needs USB adapter)");
printf("\n");
printf("\n [0] during game speeds up or slows down");
gamepad = '';
checkfirst:;
if( kbhit() )
{
gamepad = getch();
}

if(gamepad == 'T'||gamepad == 't')
{
for(delay = 0; delay < 12000; delay++)
{
system("cls");
printf("\n gamepad-A x value = %d", xgamepad());
printf("\n gamepad-A y value = %d", ygamepad());
printf("\n gamepad-B x value = %d", x2gamepad());
printf("\n gamepad-B y value = %d", y2gamepad());
printf("\n gamepad A&B value = %d", buttongamepad());
}
goto menu;
}

if(gamepad == 'g'||gamepad == 'G')
{
gamepad = 'g';
goto startgame;
}

if(gamepad == '')
{
goto checkfirst;
}

startgame:;
setpage();

loadbitmap5(1);
getch();

setpage();

gotoxy(35, 2);
if(maxspeed == 12000)
{
printf("0-slow");
}
else
{
printf("0-fast");
}

gotoxy(31,4);
if(soundopt == 'y')
{
printf("b-on sound");
}
else
{
printf("b-no sound");
}

gotoxy(1, 1);
printf("a-left, d-right, f-fire, q-quit [gunner]");
gotoxy(1, 2);
if(cheat == 'n')
{
printf("7-cheat mode is off");
}
else
{
printf("7-cheat mode is on");
}
gotoxy(1, 3);
if(gamepad == 'g'||gamepad == 'G')
{
printf("g-gamepad is in use                 ");
}
else
{
printf("g-keyboard is in use (j,k,l,i,space)");
}

for(Work = 0; Work < Lives; Work = Work + 1)
{
plotspriteLiv(Livxpos+(Work*6), Livypos);
}

looper:;

for(inttemp = 0; inttemp < 100; inttemp++)
{
plotxyc((int)doublex[inttemp], (int)doubley[inttemp], 0);
doublex[inttemp] = doublex[inttemp] + doublei[inttemp];
doubley[inttemp] = doubley[inttemp] + doublei[inttemp];

if((doublex[inttemp] >= 320.0)&&(doubley[inttemp] >= 180.0))
{
/*
plotxyc((int)doublex[inttemp], (int)doubley[inttemp], 0);
*/
doublex[inttemp] = 0.0;
doubley[inttemp] = 48.0;
}
else if(doublex[inttemp] >= 320.0)
{
/*
plotxyc((int)doublex[inttemp], (int)doubley[inttemp], 0);
*/
doublex[inttemp] = 0.0;
}
else if(doubley[inttemp] >= 180.0)
{
/*
plotxyc((int)doublex[inttemp], (int)doubley[inttemp], 0);
*/
doubley[inttemp] = 48.0;
}
plotxyc((int)doublex[inttemp], (int)doubley[inttemp], 15);

}

for(delay = 0; delay < maxspeed; delay++)
{
asm nop;
}

plotspriteGun(xpos, ypos);

if( kbhit() )
{
keypress = getch();

if(keypress == 'q')
{
goto exitroutine;
}

gotoxy(35, 2);
if(keypress == '0')
{
if(maxspeed == 12000)
{
maxspeed = 12;
printf("0-fast");
}
else
{
maxspeed = 12000;
printf("0-slow");
}
}

if(keypress == 'b'||keypress == 'B')
{
gotoxy(31,4);
if(soundopt == 'y')
{
soundopt = 'n';
printf("b-no sound");
}
else
{
soundopt = 'y';
printf("b-on sound");
}
}

if(keypress == 'g')
{
if(gamepad == 'g')
{
gamepad = '';
}
else
{
gamepad = 'g';
}
}


}

gotoxy(1, 3);
if(gamepad == 'g'||gamepad == 'G')
{
printf("g-gamepad is in use                 ");
}
else
{
printf("g-keyboard is in use (j,k,l,i,space)");
}

if(gamepad == 'g'||gamepad == 'G')
{
if(xgamepad() == 1)
{
keypress = 'a';
}

if(xgamepad() == 254)
{
keypress = 'd';
}

if((buttongamepad() == -31568))
{
keypress = ' ';
}
}


if(gamepad == 'g'||gamepad == 'G')
{

if(x2gamepad() == 1)
{
keypress = 'j';
}

if(x2gamepad() == 254)
{
keypress = 'l';
}

if(y2gamepad() == 1)
{
keypress = 'i';
}

if(y2gamepad() == 254)
{
keypress = 'k';
}

if(buttongamepad() == -31520)
{
keypress = 'f';
}

}

if(gamepad == gamepad)
{
if(keypress == 'j')
{

temp = 0;
ix = ((int)centerx);
for(iy = ((int)centery)+24; iy > ((int)centery)+5; iy--)
{
plotxyc(ix, iy, temp);
}

iy = ((int)centery);
for(ix = ((int)centerx)+12; ix > ((int)centerx)+5; ix--)
{
plotxyc(ix, iy, temp);
}

for(ix = ((int)centerx)-12; ix < ((int)centerx)-5; ix++)
{
plotxyc(ix, iy, temp);
}

ix = ((int)centerx);
for(iy = ((int)centery)-12; iy < ((int)centery)-5; iy++)
{
plotxyc(ix, iy, temp);
}

for(currentradian = 0.0; currentradian < fullradian; currentradian = currentradian + degree)
{
ix = (int)(centerx+(cos(currentradian)*radius));
iy = (int)(centery+(sin(currentradian)*radius));
plotxyc(ix, iy, 0);
}

if( centerx > radius )
{
centerx = centerx - 10.0;
}

for(currentradian = 0.0; currentradian < fullradian; currentradian = currentradian + degree)
{
ix = (int)(centerx+(cos(currentradian)*radius));
iy = (int)(centery+(sin(currentradian)*radius));
plotxyc(ix, iy, 14);
}

temp = 15;
ix = ((int)centerx);
for(iy = ((int)centery)+24; iy > ((int)centery)+5; iy--)
{
plotxyc(ix, iy, temp);
}

iy = ((int)centery);
for(ix = ((int)centerx)+12; ix > ((int)centerx)+5; ix--)
{
plotxyc(ix, iy, temp);
}

for(ix = ((int)centerx)-12; ix < ((int)centerx)-5; ix++)
{
plotxyc(ix, iy, temp);
}

ix = ((int)centerx);
for(iy = ((int)centery)-12; iy < ((int)centery)-5; iy++)
{
plotxyc(ix, iy, temp);
}

}

if( keypress == 'l' )
{

temp = 0;
ix = ((int)centerx);
for(iy = ((int)centery)+24; iy > ((int)centery)+5; iy--)
{
plotxyc(ix, iy, temp);
}

iy = ((int)centery);
for(ix = ((int)centerx)+12; ix > ((int)centerx)+5; ix--)
{
plotxyc(ix, iy, temp);
}

for(ix = ((int)centerx)-12; ix < ((int)centerx)-5; ix++)
{
plotxyc(ix, iy, temp);
}

ix = ((int)centerx);
for(iy = ((int)centery)-12; iy < ((int)centery)-5; iy++)
{
plotxyc(ix, iy, temp);
}

for(currentradian = 0.0; currentradian < fullradian; currentradian = currentradian + degree)
{
ix = (int)(centerx+(cos(currentradian)*radius));
iy = (int)(centery+(sin(currentradian)*radius));
plotxyc(ix, iy, 0);
}

if( centerx < (320.0-radius) )
{
centerx = centerx + 10.0;
}

for(currentradian = 0.0; currentradian < fullradian; currentradian = currentradian + degree)
{
ix = (int)(centerx+(cos(currentradian)*radius));
iy = (int)(centery+(sin(currentradian)*radius));
plotxyc(ix, iy, 14);
}

temp = 15;
ix = ((int)centerx);
for(iy = ((int)centery)+24; iy > ((int)centery)+5; iy--)
{
plotxyc(ix, iy, temp);
}

iy = ((int)centery);
for(ix = ((int)centerx)+12; ix > ((int)centerx)+5; ix--)
{
plotxyc(ix, iy, temp);
}

for(ix = ((int)centerx)-12; ix < ((int)centerx)-5; ix++)
{
plotxyc(ix, iy, temp);
}

ix = ((int)centerx);
for(iy = ((int)centery)-12; iy < ((int)centery)-5; iy++)
{
plotxyc(ix, iy, temp);
}

}

if( keypress == 'i' )
{

temp = 0;
ix = ((int)centerx);
for(iy = ((int)centery)+24; iy > ((int)centery)+5; iy--)
{
plotxyc(ix, iy, temp);
}

iy = ((int)centery);
for(ix = ((int)centerx)+12; ix > ((int)centerx)+5; ix--)
{
plotxyc(ix, iy, temp);
}

for(ix = ((int)centerx)-12; ix < ((int)centerx)-5; ix++)
{
plotxyc(ix, iy, temp);
}

ix = ((int)centerx);
for(iy = ((int)centery)-12; iy < ((int)centery)-5; iy++)
{
plotxyc(ix, iy, temp);
}

for(currentradian = 0.0; currentradian < fullradian; currentradian = currentradian + degree)
{
ix = (int)(centerx+(cos(currentradian)*radius));
iy = (int)(centery+(sin(currentradian)*radius));
plotxyc(ix, iy, 0);
}

if( centery > (radius+48.0) )
{
centery = centery - 10.0;
}

for(currentradian = 0.0; currentradian < fullradian; currentradian = currentradian + degree)
{
ix = (int)(centerx+(cos(currentradian)*radius));
iy = (int)(centery+(sin(currentradian)*radius));
plotxyc(ix, iy, 14);
}

temp = 15;
ix = ((int)centerx);
for(iy = ((int)centery)+24; iy > ((int)centery)+5; iy--)
{
plotxyc(ix, iy, temp);
}

iy = ((int)centery);
for(ix = ((int)centerx)+12; ix > ((int)centerx)+5; ix--)
{
plotxyc(ix, iy, temp);
}

for(ix = ((int)centerx)-12; ix < ((int)centerx)-5; ix++)
{
plotxyc(ix, iy, temp);
}

ix = ((int)centerx);
for(iy = ((int)centery)-12; iy < ((int)centery)-5; iy++)
{
plotxyc(ix, iy, temp);
}

}

if( keypress == 'k' )
{

temp = 0;
ix = ((int)centerx);
for(iy = ((int)centery)+24; iy > ((int)centery)+5; iy--)
{
plotxyc(ix, iy, temp);
}

iy = ((int)centery);
for(ix = ((int)centerx)+12; ix > ((int)centerx)+5; ix--)
{
plotxyc(ix, iy, temp);
}

for(ix = ((int)centerx)-12; ix < ((int)centerx)-5; ix++)
{
plotxyc(ix, iy, temp);
}

ix = ((int)centerx);
for(iy = ((int)centery)-12; iy < ((int)centery)-5; iy++)
{
plotxyc(ix, iy, temp);
}

for(currentradian = 0.0; currentradian < fullradian; currentradian = currentradian + degree)
{
ix = (int)(centerx+(cos(currentradian)*radius));
iy = (int)(centery+(sin(currentradian)*radius));
plotxyc(ix, iy, 0);
}

if( centery < (180.0-radius) )
{
centery = centery + 10.0;
}

for(currentradian = 0.0; currentradian < fullradian; currentradian = currentradian + degree)
{
ix = (int)(centerx+(cos(currentradian)*radius));
iy = (int)(centery+(sin(currentradian)*radius));
plotxyc(ix, iy, 14);
}

temp = 15;
ix = ((int)centerx);
for(iy = ((int)centery)+24; iy > ((int)centery)+5; iy--)
{
plotxyc(ix, iy, temp);
}

iy = ((int)centery);
for(ix = ((int)centerx)+12; ix > ((int)centerx)+5; ix--)
{
plotxyc(ix, iy, temp);
}

for(ix = ((int)centerx)-12; ix < ((int)centerx)-5; ix++)
{
plotxyc(ix, iy, temp);
}

ix = ((int)centerx);
for(iy = ((int)centery)-12; iy < ((int)centery)-5; iy++)
{
plotxyc(ix, iy, temp);
}

}

if(( keypress == ' ' )&&( Lives > 0 ))
{

if(cheat == 'n')
{
Lives = Lives - 1;
}
if(Lives < 53)
{
plotspriteBlk(Livxpos + (6*Lives), Livypos);
}
if(Lives < 1)
{
Lives = 0;
/*
goto exitroutine;
*/
}

temp = 15;
for(currentradian = radian/2.0; currentradian < (3.0/4.0)*fullradian; currentradian = currentradian + degree)
{
ix = (int)(centerx+(cos(currentradian)*radius));
iy = (int)(centery+(sin(currentradian)*radius));
if((ix-radius <= Objxpos)&&(iy == Objypos)&&(Objxpos <= ix+radius))
{
temp = 14;
if(soundopt == 'y')
{
for(frqHertz = 0; frqHertz < 1200; frqHertz++)
{
sound(frqHertz);
}
nosound();
}
}
}

if(temp == 14)
{
if(Lives < 53)
{
plotspriteLiv(Livxpos + (6*Lives), Livypos);
}
Lives = Lives + 1;
TouchCount++;
gotoxy(1, 4);
printf("goal = 100; actual = %d", TouchCount);
if(TouchCount >= 100)
{
goto YouWin;
}
}

for(radius = 0.0; radius < 25.0; radius = radius + 5.0)
{
for(currentradian = 0.0; currentradian < fullradian; currentradian = currentradian + degree)
{
ix = (int)(centerx+(cos(currentradian)*radius));
iy = (int)(centery+(sin(currentradian)*radius));
plotxyc(ix, iy, temp);
}
}

for(radius = 0.0; radius < 25.0; radius = radius + 5.0)
{
for(currentradian = 0.0; currentradian < fullradian; currentradian = currentradian + degree)
{
ix = (int)(centerx+(cos(currentradian)*radius));
iy = (int)(centery+(sin(currentradian)*radius));
plotxyc(ix, iy, 0);
}
}

radius = 25.0;
}
}

if (keypress == 'a')
{
if( xpos > 0 )
{
xpos = xpos - ipos;
}
}

if (keypress == 'd')
{
if( xpos < 320 )
{
xpos = xpos + ipos;
}
}

if (keypress == '7')
{
keypress = '';
if(cheat == 'n')
{
cheat = 'y';
}
else
{
cheat = 'n';
}
}

gotoxy(1, 2);
if(cheat == 'n')
{
printf("7-cheat mode is off");
}
else
{
printf("7-cheat mode is on ");
}

if ( (keypress == 'f')&&(Lives > 0))
{
keypress = '';
temp = 0;
CheckNextShell:;
if( ShellsetBul[temp] == 0 )
{
if(lookcount == 0)
{
lookcount = 1;
if(soundopt == 'y')
{
for(delay = 0; delay < 5000; delay++)
{
sound(1200);
}
}
}
if(cheat == 'n')
{
Lives = Lives - 1;
}
if(Lives < 53)
{
plotspriteBlk(Livxpos + (6*Lives), Livypos);
}
if(Lives < 1)
{
Lives = 0;
/*
goto exitroutine;
*/
}
ShellsetBul[temp] = 1;
}
else
{
temp = temp + 1;
if( temp < 100  )
{
goto CheckNextShell;
}
}

}



if(Lives < 1)
{
if(Patient == 0)
{
Lives = 0;
Patient++;
}
else
{
Patient++;
if(Patient > 1200)
{
plotspriteLiv(Livxpos + (6*Lives), Livypos);
Lives++;
Patient = 0;
}
}
}

for(temp = 0; temp < 100; temp++)
{
if( ShellsetBul[temp] == 1 )
{
Qn[temp] = 0.0;
ShellsetBul[temp] = 2;
ShellBulxpos[temp] = xpos;
ShellBulypos[temp] = ypos;
ShellBulipos[temp] = ipos;
}

}

for(temp = 0; temp < 100; temp++)
{


if( ShellsetBul[temp] == 2 )
{
if(lookcount > 0)
{
lookcount++;
if((lookcount >= 5))
{
lookcount = 0;
if(soundopt == 'y')
{
nosound();
}
}
}

if( ShellBulypos[temp] > 48 )
{
ShellBulypos[temp] = ShellBulypos[temp] - ShellBulipos[temp];

/*
plotspriteBul(Bulxpos, Bulypos);
*/

Qn[temp] = Qn[temp] + 0.2;
if(Qn[temp] >= 5.0)
{
Qn[temp] = 1.0;
}
if(Qn[temp] < 2.0)
{
plotspriteQ01(ShellBulxpos[temp], ShellBulypos[temp]);
}
else if(Qn[temp] < 3.0)
{
plotspriteQ02(ShellBulxpos[temp], ShellBulypos[temp]);
}
else if(Qn[temp] < 4.0)
{
plotspriteQ03(ShellBulxpos[temp], ShellBulypos[temp]);
}
else
{
plotspriteQ04(ShellBulxpos[temp], ShellBulypos[temp]);
}


}
else
{
ShellsetBul[temp] = 0;
plotspriteBlk(ShellBulxpos[temp], ShellBulypos[temp]);
ShellBulypos[temp] = 1;
ShellBulxpos[temp] = 312;
}

}


}

if(   ObjxD == 0)
{
if(Objxpos > 0)
{
Objxpos = Objxpos - Objipos;
}
else
{
ObjxD = 1;
}
}

if(ObjxD == 1   )
{
if(Objxpos < 320)
{
Objxpos = Objxpos + Objipos;
}
else
{
ObjxD = 0;
}
}

for(temp = 0; temp < 100; temp++)
{
if((((Objxpos-5)<(ShellBulxpos[temp]))&&((ShellBulxpos[temp])<(Objxpos+5)))&&(((Objypos-5)<(ShellBulypos[temp]))&&((ShellBulypos[temp])<(Objypos+5))))
{
plotspriteExp(Objxpos, Objypos);
if(soundopt == 'y')
{
for(delay = 0; delay < 5000; delay++)
{
sound(delay);
}
nosound();
}
plotspriteBlk((int)Objxpos, (int)Objypos);
Objipos = 0.1+(((double)(rand()%10))/10.0);
Objxpos = 1.0+(((double)(rand()%312))/1.0);
Objypos = 48.0+(((double)(rand()%(150-48)))/1.0);
if(Lives < 53)
{
plotspriteLiv(Livxpos + (6*Lives), Livypos);
}
Lives = Lives + 1;
TouchCount++;
gotoxy(1, 4);
printf("goal = 100; actual = %d", TouchCount);
if(TouchCount >= 100)
{
goto YouWin;
}
}
else
{
plotspriteObj(Objxpos, Objypos);
}
}

DoubleCheck:;
NotePitch = Pitch(NotePosition);
NotePosition = NotePosition + 2;
if(NotePitch == 0)
{
NotePosition = 0;
goto DoubleCheck;
}
NoteDuration = Duration(NotePosition);
sound(NotePitch);
for(NotePause = 0; NotePause < (NoteDuration*10); NotePause++)
{
asm nop;
}
nosound();

goto looper;

YouWin:;
setpage();
loadbitmap5(2);
getch();

retpage();
return(0);

YouLose:;
retpage();
printf("\n We will see you next life!");
getch();
return(0);

exitroutine:;
retpage();
return(0);
}
